#include "Fivewin.ch"
#include "Slider.ch"

STATIC oGet1[3], oSay1[2], oSay2[2], oGet2[2]
STATIC nColor1 := 255, cColor1 := "nRGB( 255, 0, 0 )"
STATIC nColor2 := 255, cColor2 := "nRGB( 255, 0, 0 )"
STATIC nColor3 := 6736896, oSlider1, oBmp1, oSlider2, oBmp2, oSay4

FUNCTION MAIN()
LOCAL oDlg, oBtn1, oBtn2, nColor := 255, oBrw1
LOCAL nRed, nGreen, nBlue, nPosSlid1 := 0.5, nPosSlid2 := 0.5, nValSlid1 := 5, nValSlid2 := 5, oSay3 
LOCAL oClick[4], nClickpos[4], aColors := {}

nClickpos[1] := 0 
nClickpos[2] := 0
nClickpos[3] := 0 
nClickpos[4] := 0

DEFINE FONT oFont NAME "Ariel" SIZE 0, -14 BOLD
DEFINE DIALOG oDlg FROM 5, 5 TO 510, 410 PIXEL TRUEPIXEL ; 
TITLE "COLOR - adjust   Rel. 3.1 / June 2021" FONT oFont  

aColors := GET_CARRAY()

@ 25, 270 XBROWSE oBrw1 SIZE 92, 63 PIXEL OF oDlg ;  
      DATASOURCE aColors COLUMNS 1, 2, 3, 4 ;
      COLSIZES 20, 20, 20, 20;	   
      CELL LINES  
FOR n := 1 to LEN( oBrw1:aCols )
      oBrw1:aCols[ n ]:bPaintText = { | oCol, hDC, cText | "" }
NEXT
WITH OBJECT oBrw1
	:lRecordSelector		:= .F. // .t.
	:lAllowRowSizing		:= .F.
	:lColDividerComplete	:= .T. // .f.
        :nColDividerStyle		:= 6
	:lAllowColSwapping		:= .F.
	:lAllowColHiding		:= .F.
	:lFastEdit				:= .F.
	:lHeader				:= .F.
	:lHScroll				:= .F.
	:lVScroll				:= .F.
	:nMarqueeStyle		:= 1
	:nRowHeight			:= 20
        :lDrawBorder			:= .F.
	I := 1
	FOR I := 1 TO 4
		:aCols[I]:lAllowSizing := .F.
	NEXT
	:aCols[1]:bClrstd	:= {|| { , aColors[ oBrw1:KeyNo() ][1] } }
	:aCols[2]:bClrstd	:= {|| { , aColors[ oBrw1:KeyNo() ][2] } }
	:aCols[3]:bClrstd	:= {|| { , aColors[ oBrw1:KeyNo() ][3] } }
	:aCols[4]:bClrstd	:= {|| { , aColors[ oBrw1:KeyNo() ][4] } }
         :CreateFromCode()
END

oBrw1:bLClicked := { | nRow, nCol | nRPos := oBrw1:KeyNo(), ;
                                                            nCPos := oBrw1:SelectedCol():nCreationOrder, ;
                                                            nColor3  := nRGB( aColors[nRPos][nCPos] ), ; 
							    oSay4:SetColor( 0, nColor3 ), ; 
                                                            oSay4:Refresh(), ; 
							    oGet1[3]:Refresh() }                                                        


// RESULT-color
@ 25, 130 SAY oSay1[1]  PROMPT "     "  OF oDlg  SIZE 100, 40  PIXEL BORDER UPDATE
oSay1[1]:SetColor( 0, nColor1 )
oSay1[1]:Refresh()

@   80, 130 GET oGet1[1] VAR nColor1  SIZE 80, 22  PICTURE "99999999"  ;
OF oDlg  Font oFont PIXEL UPDATE 

@ 115, 130 GET oGet1[2] VAR cColor1  SIZE 160, 22  OF oDlg  Font oFont PIXEL UPDATE 
cColor1 := MAKE_RGB(nColor1)
oGet1[2]:Refresh()

@ 25, 15 BITMAP oBmp1 FILENAME NIL SIZE 50, 300 OF oDlg ; // 0.5 * nrow 225 = 450
PIXEL  ADJUST BORDER UPDATE
oBmp1:bPainted := { |hDC| GET_COLOR( 1, hDC, oBmp1, nColor1 ) }
oBmp1:bLClicked  := { | nRow, nCol | nColor1 := PICK_COLOR( nRow, 25, oBmp1)[1], ; 
                                                            cColor1 := PICK_COLOR( nRow, 25, oBmp1)[2], ; 
                                                            nClickpos[1] := nRow, oClick[1]:Refresh(), ; 
                                                            nClickpos[2] := nCol, oClick[2]:Refresh(), ; 
							    oSay1[1]:SetColor( 0, nColor1 ), oSay1[1]:Refresh(), ; 
                                                            nValSlid1 := nRow / 300, oSay1[2]:Refresh(), ; 
                                                            nPosSlid1 := nValSlid1, oSay1[2]:Refresh(),;
                                                            oSlider1:Set( nValSlid1 * 10 ), oSlider1:Refresh(), ; 
							    oGet1[1]:Refresh(), oGet1[2]:Refresh() }

// calculation
// ---------------
// imageheight = 300
// sliderheight = 330
// slidertop = imagetop - 15
// slidermarks = 11 = 10 spaces
// slider-pixelrowpos = slider rowpos * 10
// sliderpos on imageclick = imagepixelpos / 300
// imagepos on sliderclick = sliderpos * 30
// image-columnpos = imagewidth / 2 = 25

@ 330, 18  SAY oClick[1]  PROMPT "R : " + ALLTRIM(STR(nClickpos[1]))  OF oDlg  SIZE 45, 20  PIXEL UPDATE
@ 350, 18  SAY oClick[2]  PROMPT "C : " + ALLTRIM(STR(nClickpos[2]))  OF oDlg  SIZE 45, 20  PIXEL UPDATE

@ 10, 70 SLIDER oSlider1 VAR nValSlid1 OF oDlg ;
            VERTICAL ;
            RANGE 0, 10 ; 
            COLORS CLR_RED, 16770764, 255 ;
            MARKS 11;
            SIZE 25, 330 PIXEL UPDATE ;    // Bitmap-height + 26
            ON CHANGE ( nPosSlid1 :=  nValSlid1 / 10 , ;
	                               oSay1[2]:Refresh(), ;  // 0.5 = centered
                                       nColor1 := PICK_COLOR( nValSlid1 * 30, 25, oBmp1 )[1], ;  
                                       cColor1 := PICK_COLOR( nValSlid1 * 30, 25, oBmp1 )[2], ; 
                                       nClickpos[1] := nValSlid1 * 30, oClick[1]:Refresh(), ; 
				       oSay1[1]:SetColor( 0, nColor1 ), oSay1[1]:Refresh(), ; 
				       oGet1[1]:Refresh(), oGet1[2]:Refresh() )
oSlider1:SetFont(  oFont )

// Slider-position
@ 168, 105 SAY oSay1[2] PROMPT nPosSlid1 OF oDlg  SIZE 30, 23  PIXEL TRANSPARENT  UPDATE
oSay1[2]:SetColor( 0, )

// -----------

@ 205, 130 SAY oSay3 PROMPT "New color-value" OF oDlg  SIZE 120, 23  PIXEL TRANSPARENT  UPDATE
oSay3:SetColor( 0, )

@ 230, 130 GET oGet1[3] VAR nColor3  SIZE 80, 22  PICTURE "99999999"  ;
OF oDlg  Font oFont PIXEL UPDATE 

@ 202, 265 SAY oSay4  PROMPT "     "  OF oDlg  SIZE 100, 20  PIXEL BORDER UPDATE
oSay4:SetColor( 0, nColor3  )
oSay4:Refresh()

@ 230, 265 BTNBMP oBtn1  OF oDlg ;
SIZE 100, 30 PIXEL TOP 2007 ; // B / H
PROMPT " Create " ;
ACTION ( nPosSlid1 := 0.5, oSay1[2]:Refresh(), ; 
                  nPosSlid2 := 0.5, oSay2[2]:Refresh(), ;  
                  COL_RESET() ) ;				
FONT oFont BORDER  
oBtn1:cToolTip =  { "Exit color tool","EXIT", 1, CLR_BLACK, 14089979 }
oBtn1:SetColor( 0, )

// -------------- 2

// RESULT-color
@ 290, 130 SAY oSay2[1]  PROMPT "     "  OF oDlg  SIZE 100, 40  PIXEL BORDER UPDATE
oSay2[1]:SetColor( 0, nColor2 )
oSay2[1]:Refresh()

@ 340, 130 GET oGet2[1] VAR nColor2  SIZE 80, 22  PICTURE "99999999"  ;
OF oDlg  Font oFont PIXEL UPDATE 

@ 340, 220 GET oGet2[2] VAR cColor2  SIZE 160, 22  OF oDlg  Font oFont PIXEL UPDATE 
cColor2 := MAKE_RGB(nColor2)
oGet2[2]:Refresh()

@ 375, 40 BITMAP oBmp2 FILENAME NIL SIZE 340, 45 OF oDlg  ; // 0.5 * nrow 225 = 450
PIXEL  ADJUST BORDER UPDATE
oBmp2:bPainted := { |hDC| GET_COLOR( 2, hDC, oBmp2, nColor2 ) }
oBmp2:bLClicked  := { | nRow, nCol | nColor2 := PICK_COLOR( 22, nCol, oBmp2)[1], ; 
                                                            cColor2 := PICK_COLOR( 22, nCol, oBmp2)[2], ; 
                                                            nClickpos[3] := nRow, oClick[3]:Refresh(), ; 
                                                            nClickpos[4] := nCol, oClick[4]:Refresh(), ; 
							    oSay2[1]:SetColor( 0, nColor2 ), oSay2[1]:Refresh(), ; 
                                                            nValSlid2 := nCol / 340, oSay2[2]:Refresh(), ; 
                                                            nPosSlid2 := nValSlid2, oSay2[2]:Refresh(),;
                                                            oSlider2:Set( nValSlid2 * 10), oSlider2:Refresh(), ; 
							    oGet2[1]:Refresh(), oGet2[2]:Refresh() }

// calculation
// ---------------
// imagewidth = 340
// sliderwidth = 370
// sliderleft = imagejeft - 15
// slidermarks = 11 = 10 spaces
// slider-pixel-colpos = slider colpos * 10
// sliderpos on imageclick = imagepixelpos / 340
// imagepos on sliderclick = sliderpos * 34
// image-rowpos = imageheight / 2 = 22


@ 460, 60  SAY oClick[3]  PROMPT "R : " + ALLTRIM(STR(nClickpos[3]))  OF oDlg  SIZE 50, 20  PIXEL UPDATE
@ 480, 60  SAY oClick[4]  PROMPT "C : " + ALLTRIM(STR(nClickpos[4]))  OF oDlg  SIZE 45, 20  PIXEL UPDATE

@ 425, 25 SLIDER oSlider2 VAR nValSlid2 OF oDlg ;
            HORIZONTAL ;
            RANGE 0, 10 ; 
            COLORS CLR_RED, 16770764, 255 ;
            MARKS 11;
            SIZE 370, 25 PIXEL UPDATE ;  // Bitmap-width + 26
            ON CHANGE ( nPosSlid2 :=  nValSlid2 / 10 , ;
	                               oSay2[2]:Refresh(), ;  // 0.5 = centered
                                       nColor2 := PICK_COLOR( 22, INT(nValSlid2 * 34 ), oBmp2 )[1], ;   
                                       cColor2 := PICK_COLOR( 22, INT(nValSlid2 * 34 ), oBmp2 )[2], ; 
                                       nClickpos[4] := INT(nValSlid2 * 34), oClick[4]:Refresh(), ;  // clickpos adjusted to bitmap
                                       oSay2[1]:SetColor( 0, nColor2 ), oSay2[1]:Refresh(), ; 
				       oGet2[1]:Refresh(), oGet2[2]:Refresh() )
oSlider2:SetFont(  oFont )

// Slider-position
@ 455, 202 SAY oSay2[2] PROMPT nPosSlid2 OF oDlg  SIZE 30, 23  PIXEL TRANSPARENT  UPDATE
oSay2[2]:SetColor( 0, )

// -----------

@ 462, 280 BTNBMP oBtn2  OF oDlg ;
SIZE 100, 30 PIXEL TOP 2007 ; // B / H
PROMPT " EXIT " ;
ACTION oDlg:End() ;				
FONT oFont BORDER  
oBtn2:cToolTip =  { "Exit color tool","EXIT", 1, CLR_BLACK, 14089979 }
oBtn2:SetColor( 0, )

ACTIVATE DIALOG oDlg CENTER  

Release FONT oFont

RETURN( NIL )

//--------

STATIC FUNCTION COL_RESET()

oGet1[3]:Refresh()
nColor1 := nColor3
nColor2 := nColor3
cColor1 := MAKE_RGB(nColor3)
cColor2 := MAKE_RGB(nColor3)
oSay1[1]:SetColor( 0, nColor3 )
oSay2[1]:SetColor( 0, nColor3 )
oSay1[1]:Refresh()
oSay2[1]:Refresh()
oGet1[1]:Refresh()
oGet1[2]:Refresh()
oGet2[1]:Refresh()
oGet2[2]:Refresh()
oGet1[3]:Refresh()

oBmp1:Refresh()
oBmp2:Refresh()		

oSlider1:Set( 5 )
oSlider1:Refresh()
oSlider2:Set( 5 )
oSlider2:Refresh()

RETURN( NIL )

// ------------

STATIC FUNCTION GET_CARRAY()
LOCAL aColors := { { nRGB( 0, 0, 255 ), nRGB( 0, 128, 255 ), nRGB( 0, 255, 128 ), nRGB( 255, 255, 255 ) },; 
                                  { nRGB( 255, 0, 0 ), nRGB( 255, 255, 0 ), nRGB( 255, 51, 255 ), nRGB( 128, 128, 0 ) },;                 
                                  { nRGB( 128, 0, 0 ), nRGB( 255, 128, 0 ), nRGB( 192, 192, 192 ), nRGB( 0, 128, 64 ) } }

RETURN( aColors )

//---------  

STATIC FUNCTION GET_COLOR( nType, hDC, oBmp, nColor ) 
LOCAL oBMPBrush
LOCAL aRect := GETCLIENTRECT( oBmp:hWnd )

aGrad := { { .5, CLR_WHITE, nColor }, { .5, nColor, CLR_BLACK } }

IF nType = 1
	DEFINE BRUSH oBMPBrush COLOR GradientFill( hDC,  0, 0, aRect[3], aRect[4], aGrad, .T. ) // .T: = Vertical
ELSE
	DEFINE BRUSH oBMPBrush COLOR GradientFill( hDC,  0, 0, aRect[3], aRect[4], aGrad, .F. ) // .T: = Vertical
ENDIF
oBMPBrush:End()

RETURN( NIL )

//-----------

STATIC FUNCTION PICK_COLOR( nPos, nLeftTop, oBmp )
LOCAL aColors[2]	
LOCAL hDC := CreateCompatibleDC( oBmp:GetDC() )
LOCAL nRed, nGreen, nBlue

aColors[1]	:= GetPixel( oBmp:hDC, nLeftTop, nPos )
IF aColors[1] < 0
	aColors[1] := 0 
ENDIF
nRed		:= nRGBRed( aColors[1] )
nGreen		:= nRGBGreen( aColors[1] )
nBlue		:= nRGBBlue( aColors[1] )
aColors[2]	:= "nRGB( " + ALLTRIM(STR(nRed)) + ", " + ;
			    ALLTRIM(STR(nGreen)) + ", " + ;
			    ALLTRIM(STR(nBlue)) + " )"
oBmp:ReleaseDC()

RETURN aColors

//-----------

STATIC FUNCTION MAKE_RGB(nColor)

nRed := nRGBRed( nColor )
nGreen := nRGBGreen( nColor )
nBlue := nRGBBlue( nColor )

cColor := "nRGB( " + ALLTRIM(STR(nRed)) + ", " + ;
		     ALLTRIM(STR(nGreen)) + ", " + ;
		     ALLTRIM(STR(nBlue)) + " )"
									 
RETURN( cColor )

